#include <iostream>

#include "jabatoSchedule.h"

jabatoBlockHandler::jabatoBlockHandler()
{
  //I BET YOU KNOW HOW TO THIS MUCH BETTER. THEY ARE USED AS SIMPLE CONSTANTS!!
  BLOCK = XMLString::transcode("BLOCK");
  PROGRAMFILE = XMLString::transcode("PROGRAMFILE");
  SONGSDIR = XMLString::transcode("SONGSDIRECTORY");
  SLOTSDIR = XMLString::transcode("SLOTSDIRECTORY");
  TEXTSDIR = XMLString::transcode("TEXTSDIRECTORY");

  ID = XMLString::transcode("ID");
  NAME = XMLString::transcode("NAME");
  SONGSPERSLOT = XMLString::transcode("SONGSPERSLOT");
  SHUFFLE = XMLString::transcode("SHUFFLE");

  PATH = XMLString::transcode("PATH");
  TOLANDISKCMD = XMLString::transcode("TOLANDISKCMD");
  TOWANDISKCMD = XMLString::transcode("TOWANDISKCMD");

  jabatoBlock = NULL;
  m_found = false;
  addDirectories=true;
}

jabatoBlockHandler::~jabatoBlockHandler()
{
  //I BET YOU KNOW HOW TO THIS MUCH BETTER. THEY ARE USED AS SIMPLE CONSTANTS!!
  delete BLOCK;
  delete PROGRAMFILE;
  delete SONGSDIR;
  delete SLOTSDIR;
  delete TEXTSDIR;
  delete ID;
  delete NAME;
  delete SONGSPERSLOT;
  delete SHUFFLE;
  delete PATH;
  delete TOLANDISKCMD;
  delete TOWANDISKCMD;
}


void
jabatoBlockHandler::setAddDirectories(bool b) {
  addDirectories = b;
}

void
jabatoBlockHandler::find(int id, JabatoBlock *block){
  blockId = id;
  jabatoBlock = block;
  m_found = false;
  m_error = false;
}

bool
jabatoBlockHandler::found(){
  return m_found;
}

bool
jabatoBlockHandler::error(){
  return m_error;
}


// ---------------------------------------------------------------------------
//  jabatoBlockHandler: Overrides of the SAX ErrorHandler interface
// ---------------------------------------------------------------------------
void jabatoBlockHandler::error(const SAXParseException& e)
{
    cerr << "\nError at file " << StrX(e.getSystemId())
		     << ", line " << e.getLineNumber()
    		 << ", char " << e.getColumnNumber()
         << "\n  Message: " << StrX(e.getMessage()) << endl;
    m_found = false;
    m_error = true;
}

void jabatoBlockHandler::fatalError(const SAXParseException& e)
{
    cerr << "\nFatal Error at file " << StrX(e.getSystemId())
    		 << ", line " << e.getLineNumber()
	    	 << ", char " << e.getColumnNumber()
         << "\n  Message: " << StrX(e.getMessage()) << endl;
  m_found = false;
  m_error = true;
}

void jabatoBlockHandler::warning(const SAXParseException& e)
{
  cerr << "\nWarning at file " << StrX(e.getSystemId())
  		 << ", line " << e.getLineNumber()
	  	 << ", char " << e.getColumnNumber()
       << "\n  Message: " << StrX(e.getMessage()) << endl;
  m_found = false;
  m_error = true;
}

// ---------------------------------------------------------------------------
//  jabatoBlockHandler: Overrides of the SAX DocumentHandler interface
// ---------------------------------------------------------------------------

void jabatoBlockHandler::characters(const     XMLCh* const    chars
                                  , const   unsigned int    length)
{
//    fFormatter.formatBuf(chars, length, XMLFormatter::CharEscapes);
}

void jabatoBlockHandler::endElement(const XMLCh* const uri,
								 const XMLCh* const localname,
								 const XMLCh* const qname)
{
  if (m_found && readingBlock)
    if(XMLString::compareIString(qname, BLOCK)==0)
      readingBlock = false;
}

void jabatoBlockHandler::startElement(const   XMLCh* const    uri,
									const   XMLCh* const    localname,
									const   XMLCh* const    qname,
                                    const   Attributes&		attributes)
{
 if(jabatoBlock)
 {
  if (!m_found)
  {
    if(XMLString::compareIString(qname, BLOCK)==0)
    {
      char *transcoded = NULL;
      uint id;
      try
      {
        readingBlock = false;
        if (XMLString::textToBin(attributes.getValue(ID), id)) {
          if(m_found = ((int)id==blockId))
          {
            uint songs;
            uint shuff;
            jabatoBlock->setId(blockId);

            transcoded = XMLString::transcode(attributes.getValue(NAME));
            jabatoBlock->setName(transcoded);
            delete transcoded;
            transcoded = 0;

            readingBlock = true; //activate data regard
            //optional ATTRIBS
            if (XMLString::textToBin(attributes.getValue(SONGSPERSLOT), songs))
              jabatoBlock->setSongsPerSlot((int)songs);
            if (XMLString::textToBin(attributes.getValue(SHUFFLE), shuff))
              jabatoBlock->setShuffleType((int)shuff);
          }
        }
      }
      catch (...)
      {
        if(transcoded) delete transcoded;
				m_found = readingBlock;   // id + name ?
      }
    }
  }
  else
    if(readingBlock) {
      char *path = NULL;
      try {
        path = XMLString::transcode(attributes.getValue(PATH));

        if(XMLString::compareIString(qname, PROGRAMFILE)==0) {
          jabatoBlock->setProgramFile(path);

	        unsigned int len = attributes.getLength();
	        for (unsigned int index = 0; index < len; index++)
	        {
				    if(XMLString::compareIString(attributes.getQName(index),TOLANDISKCMD) == 0) {
            	delete path;
            	path = XMLString::transcode(attributes.getValue(index));
			      	jabatoBlock->setProgramToLanDiskCmd(path);
			    	}
			    	else if(XMLString::compareIString(attributes.getQName(index),TOWANDISKCMD) == 0) {
            	delete path;
            	path = XMLString::transcode(attributes.getValue(index));
			      	jabatoBlock->setProgramToWanDiskCmd(path);
			    	}
          }
        }
        else if(XMLString::compareIString(qname, SONGSDIR)==0)
        {
          if(addDirectories) {
            jabatoBlock->addSongsDirectory(path, "*.mp3 *.MP3 *.ogg *.OGG");
          }
        }
        else if(XMLString::compareIString(qname, SLOTSDIR)==0)
        {
          if(addDirectories) {
            jabatoBlock->addSlotsDirectory(path, 
			    "*.mp3 *.MP3 *.ogg *.OGG *.festival *.FESTIVAL");
          }
        }
        else if(XMLString::compareIString(qname, TEXTSDIR)==0)
        {
          if(addDirectories) {
            jabatoBlock->addTextsDirectory(path, "*.festival *.FESTIVAL");
	  }
	}
        else
          cerr << "ERROR IN jBF FILE: Unknown block sub-tag <" << StrX(qname) << ">\n";
        delete path;
      }
      catch (...){
        if(path) delete path;
        cerr << "ERROR IN jBF FILE: " << StrX(qname) << " tag without path attribute! \n";
      }
    }
 }
}

